import org.junit.jupiter.api.Test;

import io.fabric8.kubernetes.api.model.Pod;
import io.fabric8.kubernetes.api.model.PodList;
import io.fabric8.kubernetes.client.KubernetesClient;
import io.fabric8.kubernetes.client.dsl.NonNamespaceOperation;
import io.fabric8.kubernetes.client.dsl.PodResource;
import io.quarkus.test.junit.QuarkusTest;
import jakarta.inject.Inject;

@QuarkusTest
public class MyTest {
    @Inject
    private KubernetesClient kubernetesClient;
    
    @Test
    public void test() {
        // create pod
        var pod = new io.fabric8.kubernetes.api.model.PodBuilder()
            .withNewMetadata().withName("test-pod").endMetadata()
            .withNewSpec().addNewContainer().withName("test-container").withImage("busybox").withCommand("sleep", "3600").endContainer().endSpec()
            .build();
        NonNamespaceOperation<Pod, PodList, PodResource> podOperation = this.kubernetesClient.pods().inNamespace("default");
        podOperation.resource(pod).create();

        System.out.println("pod list:");
        var pods = this.kubernetesClient.pods().list();
        pods.getItems().forEach(p -> {
            System.out.println(p.getMetadata().getName());
        });
    }
}
